diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-emlsr-test.cc ns-3.40/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.39/src/wifi/test/wifi-emlsr-test.cc	2023-07-05 14:23:48.129428400 -0700
+++ ns-3.40/src/wifi/test/wifi-emlsr-test.cc	2023-09-27 13:30:37.922839900 -0700
@@ -1949,8 +2019,8 @@
     // transitioned to active mode instead
     for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
     {
-        bool psModeExpected = *staId < m_nEmlsrStations && linkId != m_assocLinkId.at(*staId + 1) &&
-                              m_emlsrLinks.count(linkId) == 1;
+        bool psModeExpected =
+            *staId < m_nEmlsrStations && linkId != m_mainPhyId && m_emlsrLinks.count(linkId) == 1;
         auto addr = m_staMacs.at(*staId)->GetAddress();
         auto psMode = m_apMac->GetWifiRemoteStationManager(linkId)->IsInPsMode(addr);
         NS_TEST_EXPECT_MSG_EQ(psMode,
@@ -1959,18 +2029,14 @@
                                             << " not in " << (psModeExpected ? "PS" : "active")
                                             << " mode");
         // check that AP is blocking transmission of QoS data frames on this link
-        WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
-        auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
-        NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                              true,
-                              "Expected to find a mask for EMLSR link "
-                                  << +linkId << " of EMLSR client " << *staId);
-        auto reason = static_cast<std::size_t>(WifiQueueBlockedReason::POWER_SAVE_MODE);
-        NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                              psModeExpected,
-                              "Expected EMLSR link " << +linkId << " of EMLSR client " << *staId
-                                                     << " to be "
-                                                     << (psModeExpected ? "blocked" : "unblocked"));
+        CheckBlockedLink(m_apMac,
+                         addr,
+                         linkId,
+                         WifiQueueBlockedReason::POWER_SAVE_MODE,
+                         psModeExpected,
+                         "Checking PM mode after association on AP MLD for EMLSR client " +
+                             std::to_string(*staId),
+                         false);
     }
 }
 
@@ -1983,7 +2049,7 @@
     auto pkt = mpdu->GetPacket()->Copy();
     const auto& hdr = mpdu->GetHeader();
     WifiActionHeader::Remove(pkt);
-    MgtEmlOperatingModeNotification frame;
+    MgtEmlOmn frame;
     pkt->RemoveHeader(frame);
 
     std::optional<std::size_t> staId;
@@ -2026,18 +2092,15 @@
                                       "EMLSR link " << +linkId << " of EMLSR client " << *staId
                                                     << " not in active mode");
                 // check that AP is not blocking transmission of QoS data frames on this link
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
-                auto mask =
-                    m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
-                NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                      true,
-                                      "Expected to find a mask for EMLSR link "
-                                          << +linkId << " of EMLSR client " << *staId);
-                auto reason = static_cast<std::size_t>(WifiQueueBlockedReason::POWER_SAVE_MODE);
-                NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                      false,
-                                      "Expected EMLSR link " << +linkId << " of EMLSR client "
-                                                             << *staId << " to be unblocked");
+                CheckBlockedLink(
+                    m_apMac,
+                    addr,
+                    linkId,
+                    WifiQueueBlockedReason::POWER_SAVE_MODE,
+                    false,
+                    "Checking EMLSR links on AP MLD after EMLSR mode is enabled on EMLSR client " +
+                        std::to_string(*staId),
+                    false);
             }
         }
         else
@@ -2056,18 +2119,15 @@
                                           << +id << " of EMLSR client " << *staId << " not in "
                                           << (psModeExpected ? "PS" : "active") << " mode");
                 // check that AP is blocking transmission of QoS data frames on this link
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
-                auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                      true,
-                                      "Expected to find a mask for EMLSR link "
-                                          << +id << " of EMLSR client " << *staId);
-                auto reason = static_cast<std::size_t>(WifiQueueBlockedReason::POWER_SAVE_MODE);
-                NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                      psModeExpected,
-                                      "Expected EMLSR link "
-                                          << +id << " of EMLSR client " << *staId << " to be "
-                                          << (psModeExpected ? "blocked" : "unblocked"));
+                CheckBlockedLink(
+                    m_apMac,
+                    addr,
+                    id,
+                    WifiQueueBlockedReason::POWER_SAVE_MODE,
+                    psModeExpected,
+                    "Checking links on AP MLD after EMLSR mode is disabled on EMLSR client " +
+                        std::to_string(*staId),
+                    false);
             }
         }
     });
@@ -2128,53 +2188,28 @@
                     continue;
                 }
 
-                if (id == linkId)
-                {
-                    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *addr, 0);
-                    auto mask =
-                        m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                    NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                          true,
-                                          "Expected to find a mask for EMLSR link "
-                                              << +id << " of EMLSR client " << *addr);
-                    NS_TEST_EXPECT_MSG_EQ(mask->none(),
-                                          true,
-                                          "Expected EMLSR link " << +id << " of EMLSR client "
-                                                                 << *addr << " to be unblocked");
-                    continue;
-                }
-
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, *addr, 0);
-                auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                      true,
-                                      "Expected to find a mask for EMLSR link "
-                                          << +id << " of EMLSR client " << *addr);
-                auto reason =
-                    static_cast<std::size_t>(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
-                NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                      true,
-                                      "Expected EMLSR link " << +id << " of EMLSR client " << *addr
-                                                             << " to be blocked");
-                NS_TEST_EXPECT_MSG_EQ(mask->count(),
-                                      1,
-                                      "Expected EMLSR link "
-                                          << +id << " of EMLSR client " << *addr
-                                          << " to be blocked for one reason only");
+                CheckBlockedLink(m_apMac,
+                                 *addr,
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking that AP blocked transmissions on all other EMLSR "
+                                 "links after sending ICF to client with AID=" +
+                                     std::to_string(userInfo.GetAid12()));
             }
         }
     }
 
     NS_TEST_EXPECT_MSG_EQ(found, true, "Expected ICF to be addressed to at least an EMLSR client");
 
+    auto txDuration = WifiPhy::CalculateTxDuration(mpdu->GetSize(),
+                                                   txVector,
+                                                   m_apMac->GetWifiPhy(linkId)->GetPhyBand());
+
     if (maxPaddingDelay.IsStrictlyPositive())
     {
         // compare the TX duration of this Trigger Frame to that of the Trigger Frame with no
         // padding added
-        auto txDurationWith =
-            WifiPhy::CalculateTxDuration(mpdu->GetSize(),
-                                         txVector,
-                                         m_apMac->GetWifiPhy(linkId)->GetPhyBand());
         trigger.SetPaddingSize(0);
         auto pkt = Create<Packet>();
         pkt->AddHeader(trigger);
@@ -2183,11 +2218,40 @@
                                          txVector,
                                          m_apMac->GetWifiPhy(linkId)->GetPhyBand());
 
-        NS_TEST_EXPECT_MSG_EQ(txDurationWith,
+        NS_TEST_EXPECT_MSG_EQ(txDuration,
                               txDurationWithout + maxPaddingDelay,
                               "Unexpected TX duration of the MU-RTS TF with padding "
                                   << maxPaddingDelay.As(Time::US));
     }
+
+    // check that the EMLSR clients have blocked transmissions on other links after
+    // receiving this ICF
+    for (const auto& userInfo : trigger)
+    {
+        for (std::size_t i = 0; i < m_nEmlsrStations; i++)
+        {
+            if (m_staMacs[i]->GetAssociationId() != userInfo.GetAid12())
+            {
+                continue;
+            }
+
+            Simulator::Schedule(txDuration + NanoSeconds(5), [=]() {
+                for (uint8_t id = 0; id < m_staMacs[i]->GetNLinks(); id++)
+                {
+                    // non-EMLSR links or links on which ICF is received are not blocked
+                    CheckBlockedLink(m_staMacs[i],
+                                     m_apMac->GetAddress(),
+                                     id,
+                                     WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                     id != linkId && m_staMacs[i]->IsEmlsrLink(id),
+                                     "Checking EMLSR links on EMLSR client " + std::to_string(i) +
+                                         " after receiving ICF");
+                }
+            });
+
+            break;
+        }
+    }
 }
 
 void
@@ -2217,80 +2281,95 @@
         // generate another small packet addressed to the first EMLSR client only
         m_apMac->GetDevice()->GetNode()->AddApplication(
             GetApplication(DOWNLINK, firstClientId, 1, 40));
+        // both EMLSR clients are about to receive a QoS data frame
+        for (std::size_t clientId : {firstClientId, secondClientId})
+        {
+            Simulator::Schedule(txDuration, [=]() {
+                for (uint8_t id = 0; id < m_staMacs[clientId]->GetNLinks(); id++)
+                {
+                    // link on which QoS data is received is not blocked
+                    CheckBlockedLink(m_staMacs[clientId],
+                                     m_apMac->GetAddress(),
+                                     id,
+                                     WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                     id != linkId,
+                                     "Checking EMLSR links on EMLSR client " +
+                                         std::to_string(clientId) +
+                                         " after receiving the first QoS data frame");
+                }
+            });
+        }
         break;
     case 2:
         // generate another small packet addressed to the second EMLSR client
         m_apMac->GetDevice()->GetNode()->AddApplication(
             GetApplication(DOWNLINK, secondClientId, 1, 40));
 
+        // when the transmission of the second QoS data frame starts, both EMLSR clients are
+        // still blocking all the links but the one used to receive the QoS data frame
+        for (std::size_t clientId : {firstClientId, secondClientId})
+        {
+            for (uint8_t id = 0; id < m_staMacs[clientId]->GetNLinks(); id++)
+            {
+                // link on which QoS data is received is not blocked
+                CheckBlockedLink(m_staMacs[clientId],
+                                 m_apMac->GetAddress(),
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking EMLSR links on EMLSR client " +
+                                     std::to_string(clientId) +
+                                     " when starting the reception of the second QoS frame");
+            }
+        }
+
         // the EMLSR client that is not the recipient of the QoS frame being transmitted will
         // switch back to listening mode after a transition delay starting from the end of
         // the PPDU carrying this QoS data frame
 
-        // immediately before the end of the PPDU, this link is not blocked for the EMLSR client
+        // immediately before the end of the PPDU, this link only is not blocked for the EMLSR
+        // client on the AP MLD
         Simulator::Schedule(txDuration - NanoSeconds(1), [=]() {
-            WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
-            auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
-            NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                  true,
-                                  "Expected to find a mask for EMLSR link "
-                                      << +linkId << " of EMLSR client " << secondClientId);
-            NS_TEST_EXPECT_MSG_EQ(mask->none(),
-                                  true,
-                                  "Expected EMLSR link " << +linkId << " of EMLSR client "
-                                                         << secondClientId << " to be unblocked");
+            for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+            {
+                CheckBlockedLink(m_apMac,
+                                 addr,
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking that links of EMLSR client " +
+                                     std::to_string(secondClientId) +
+                                     " are blocked on the AP MLD before the end of the PPDU");
+            }
         });
-        // immediately before the end of the PPDU, the other links are blocked for the EMLSR client
+        // immediately before the end of the PPDU, all the links on the EMLSR client that is not
+        // the recipient of the second QoS frame are unblocked (they are unblocked when the
+        // PHY-RXSTART.indication is not received)
         Simulator::Schedule(txDuration - NanoSeconds(1), [=]() {
-            for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+            for (uint8_t id = 0; id < m_staMacs[secondClientId]->GetNLinks(); id++)
             {
-                if (id == linkId)
-                {
-                    continue;
-                }
-
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
-                auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                      true,
-                                      "Expected to find a mask for EMLSR link "
-                                          << +id << " of EMLSR client " << secondClientId);
-                auto reason =
-                    static_cast<std::size_t>(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK);
-                NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                      true,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << secondClientId << " to be blocked");
-                NS_TEST_EXPECT_MSG_EQ(mask->count(),
-                                      1,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << secondClientId
-                                                             << " to be blocked "
-                                                                " for one reason only");
+                CheckBlockedLink(m_staMacs[secondClientId],
+                                 m_apMac->GetAddress(),
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 false,
+                                 "Checking that links of EMLSR client " +
+                                     std::to_string(secondClientId) +
+                                     " are unblocked before the end of the second QoS frame");
             }
         });
         // immediately after the end of the PPDU, all links are blocked for the EMLSR client
         Simulator::Schedule(txDuration + NanoSeconds(1), [=]() {
             for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
             {
-                WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
-                auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                      true,
-                                      "Expected to find a mask for EMLSR link "
-                                          << +id << " of EMLSR client " << secondClientId);
-                auto reason = static_cast<std::size_t>(
-                    WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY);
-                NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                      true,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << secondClientId << " to be blocked");
-                NS_TEST_EXPECT_MSG_EQ(mask->count(),
-                                      1,
-                                      "Expected EMLSR link " << +id << " of EMLSR client "
-                                                             << secondClientId
-                                                             << " to be blocked "
-                                                                " for one reason only");
+                CheckBlockedLink(m_apMac,
+                                 addr,
+                                 id,
+                                 WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                                 true,
+                                 "Checking links of EMLSR client " +
+                                     std::to_string(secondClientId) +
+                                     " are all blocked on the AP MLD after the end of the PPDU");
             }
         });
         // immediately before the transition delay, all links are still blocked for the EMLSR client
@@ -2299,37 +2378,42 @@
             [=]() {
                 for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
                 {
-                    WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
-                    auto mask =
-                        m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, id);
-                    NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                          true,
-                                          "Expected to find a mask for EMLSR link "
-                                              << +id << " of EMLSR client " << secondClientId);
-                    auto reason = static_cast<std::size_t>(
-                        WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY);
-                    NS_TEST_EXPECT_MSG_EQ(mask->test(reason),
-                                          true,
-                                          "Expected EMLSR link " << +id << " of EMLSR client "
-                                                                 << secondClientId
-                                                                 << " to be blocked");
-                    NS_TEST_EXPECT_MSG_EQ(mask->count(),
-                                          1,
-                                          "Expected EMLSR link " << +id << " of EMLSR client "
-                                                                 << secondClientId
-                                                                 << " to be blocked "
-                                                                    " for one reason only");
+                    CheckBlockedLink(
+                        m_apMac,
+                        addr,
+                        id,
+                        WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                        true,
+                        "Checking links of EMLSR client " + std::to_string(secondClientId) +
+                            " are all blocked on the AP MLD before the transition delay");
                 }
             });
 
         break;
+    case 3:
+        // at the end of the third QoS frame, this link only is not blocked on the EMLSR
+        // client receiving the frame
+        Simulator::Schedule(txDuration, [=]() {
+            for (uint8_t id = 0; id < m_apMac->GetNLinks(); id++)
+            {
+                CheckBlockedLink(m_staMacs[secondClientId],
+                                 m_apMac->GetAddress(),
+                                 id,
+                                 WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                 id != linkId,
+                                 "Checking EMLSR links on EMLSR client " +
+                                     std::to_string(secondClientId) +
+                                     " after receiving the third QoS data frame");
+            }
+        });
+        break;
     }
 }
 
 void
 EmlsrDlTxopTest::CheckBlockAck(const WifiConstPsduMap& psduMap,
                                const WifiTxVector& txVector,
-                               uint8_t linkId)
+                               uint8_t phyId)
 {
     if (m_nEmlsrStations != 2 || m_apMac->GetNLinks() != m_emlsrLinks.size() ||
         m_emlsrEnabledTime.IsZero() || Simulator::Now() < m_emlsrEnabledTime + m_fe2to3delay)
